//----------------------------------------------------------------------------
// C main line
//----------------------------------------------------------------------------

#include <m8c.h>        // part specific constants and macros
#include "PSoCAPI.h"    // PSoC API definitions for all User Modules
#include "delay.h"
#include <math.h>
volatile int  tick2ms =0;
volatile int  tick1s =0;
volatile char flag2ms=0;
//int result;
//int i = 0;

#pragma interrupt_handler Timer8_1_ISR
void Timer8_1_ISR(void)
{
	flag2ms=1;
	tick2ms++;
	if (tick2ms == 500) //output period of timer is 2ms, so I set the interrupt to get 1s
	{	tick2ms = 1;
		tick1s++;
	}
}

void Start(void)
{
	DAC9_1_Start(DAC9_1_HIGHPOWER);
	DAC9_2_Start(DAC9_2_HIGHPOWER);
	Timer8_1_EnableInt();
	Timer8_1_Start();
	//LED_1_Start();
	PGA_1_Start(PGA_1_HIGHPOWER);
	ADCINC_1_Start(ADCINC_1_HIGHPOWER);
	ADCINC_1_GetSamples(0);
	UART_1_IntCntl(UART_1_ENABLE_RX_INT);	
	UART_1_EnableInt();	
	UART_1_Start(UART_1_PARITY_NONE);	
	
}

/*void Toggle_LED(void)
{
	if (tick1s%2==0)
	{
		//flag2ms=0;
		LED_1_Invert();
	}
}	*/
char buffer[5];
	void send_ADC(int Data)
	{
		buffer[0] = Data/1000+ '0';
		buffer[1] = (Data%1000)/100 + '0';
		buffer[2] = ((Data%100)/10) + '0';
		buffer[3] = ((Data%100)%10) + '0';
		buffer[4] = '\0';
		UART_1_PutString(buffer);
		UART_1_PutChar(10);
	}
int readadc(void)
	{
		//while (ADCINC_1_fIsDataAvailable()==0);
		return ADCINC_1_iClearFlagGetData();
		//}
	}
void Timer_DAC(void)
{
	static int result;
	static int DAC_value_2_05V = 167;
	static int DAC_value_2_2V = 198;
	static int DAC_value_3_1V = 373;
	
	if (tick1s<10)  //DAC output 2.05V if the time is below 10s, the analog output value is later offset by -2.5V
	{
		
		
		if(ADCINC_1_fIsDataAvailable())
		   result = readadc();
		send_ADC(result);
	}
	if (tick1s==10)      //DAC output increase with rate of change 0.15V/s
	{	
			if(tick2ms%32==0 && flag2ms)
			{
				flag2ms=0;
				DAC_value_2_05V +=1;
				DAC9_1_WriteStall(DAC_value_2_05V);
			}
			DAC9_2_WriteStall(255);
			if(ADCINC_1_fIsDataAvailable())
				result = readadc();
			send_ADC(result);
			
	}
	if (tick1s<20 && tick1s > 10)   //DAC output at 2.2V
	{
		DAC9_1_WriteStall(DAC_value_2_2V);
		DAC9_2_WriteStall(255);
		result = readadc();
		send_ADC(result);
	}
	if (tick1s==20)   // DAC output increase to 3.1V with rate of change 1V/s
	{	
			if(tick2ms%6==0 && flag2ms)	
			{
				flag2ms=0;
				DAC_value_2_2V +=1;
				DAC9_1_WriteStall(DAC_value_2_2V);
			}
			if(ADCINC_1_fIsDataAvailable())
				result = readadc();
			send_ADC(result);
			
	}
	if (tick1s > 20 && tick1s < 50)
	{
		DAC9_1_WriteStall(DAC_value_3_1V);
		if(ADCINC_1_fIsDataAvailable())
			result = readadc();
		send_ADC(result);
	}

	//DAC9_1_Stop();
}

/*void Delay1ms(void)
	{
		Delay50uTimes(20);	
	}
	/*
void Delay_ms(WORD factor)
	{
		Delay1ms(factor);
	}*/
	
void main1(void)
	{
	//int result;
	//result = readadc();
	//send_ADC(result);
	DAC9_1_WriteStall(DAC_value_2_05V);
	DAC9_2_WriteStall(255);
	//Timer_DAC();
		while (1)
		{
			Timer_DAC();
			//result = readadc();
			//send_ADC(result);
		}
	}
void main(void)
{
	 M8C_EnableGInt ; // Uncomment this line to enable Global Interrupts
	// Insert your main routine code here.
	M8C_EnableIntMask(INT_MSK1, INT_MSK1_DBB00);
	Start();
	main1();
	//Timer_DAC();
	//while (1);
	/*{
		while (ADCINC_1_fIsDataAvailable() == 0);
		result = ADCINC_1_iClearFlagGetData();
		send_ADC(result);
		Delay1ms();
	}*/
	
}
